#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/rope>

#define mp make_pair
#define mt make_tuple
#define sz size()
#define pb push_back
#define SPED ios_base::sync_with_stdio(false);cin.tie(0);cout.tie(0);cerr.tie(0)
#define all(x) (x).begin(),(x).end()
#define allr(x) (x).rbegin(),(x).rend()
#define inv(n) power((n), mod - 2)
#define ff(i,a,b) for (int (i) = (a); (i) < (b); (i)++)
#define fff(i,a,b) for (int (i) = (a); (i) <= b; (i)++)
#define bff(i,a,b) for (int (i) = (b)-1; (i) >= (a); (i)--)
#define bfff(i,a,b) for (int (i) = (b); (i) >= (a); (i)--)
#define sum_overflow(a,b) __builtin_add_overflow_p ((a), (b), (__typeof__ ((a) + (b))) 0)
#define mul_overflow(a,b) __builtin_mul_overflow_p ((a), (b), (__typeof__ ((a) * (b))) 0)
#define popcount(x) __builtin_popcountll(x)
#define PI 3.14159265358979323846

using namespace std;
using namespace __gnu_pbds;
using namespace __gnu_cxx;

typedef long long int ll;
typedef long double ld;
typedef unsigned long long int ull;
typedef pair<ll,ll> pll;
typedef vector<vector<ll>> graf;
typedef array<ll,3> all;
typedef array<double,3> add;

const ll mod = 1e9+7;
const ll MOD = 998244353;
const ll MAXN = 800005;
const ll INF = 1e18;

template <class T> using ordered_set = tree<T, null_type,less<T>, rb_tree_tag,tree_order_statistics_node_update>;
template <class T> using ordered_multiset = tree<T, null_type,less_equal<T>, rb_tree_tag,tree_order_statistics_node_update>;

graf g(MAXN);



ll ans(vector<ll>& a, ll n)
{
    vector<ll> outarr(n+1);
    ll minn = INF;
    ll ind = -1;
    fff(i,1,n)
    {
        vector<bool> vis(n+1);
        queue<pll> q;
        vis[i]=true;
        q.emplace(mp(i,0));
        while(!q.empty())
        {
            pll qq = q.front();
            q.pop();
            outarr[i]+=qq.second*a[qq.first];
            for(auto u : g[qq.first])
            {
                if(!vis[u])
                {
                    vis[u]=true;
                    q.emplace(mp(u,qq.second+1));
                }
            }
        }
        if(outarr[i]<minn)
        {
            minn=outarr[i];
            ind=i;
        }
    }
    return ind;
}

int main()
{
    SPED;
    ll n;
    cin >> n;
    ff(i,0,n-1)
    {
        ll x,y;
        cin >> x >> y;
        g[x].pb(y);
        g[y].pb(x);
    }
    vector<ll> a(n+1);
    fff(i,1,n)
    cin >> a[i];
    cout << ans(a,n) << "\n";
    ll q;
    cin >> q;
    while(q--)
    {
        ll br,ind;
        cin >> br >> ind;
        a[ind]+=br;
        cout << ans(a,n) << "\n";
    }
    return 0;
}